#include "stdlib.h"

struct node {
	int value;
	struct node *next;
};

/*@

predicate node(struct node *no, struct node *ne)
	= no->value |-> ?v &*& no->next |-> ne;

@*/

struct llist {
	struct node *head;
};

/*@

predicate llist(struct llist *n)
	= n->head |-> ?np &*& list(np);
	
predicate list(struct node *n)
	= n == 0 ? emp
	         : node(n, ?ne) &*& list(ne);
	         
@*/

void reverse(struct llist *l)
	//@ requires llist(l);
	//@ ensures llist(l);
{
	struct node *previous = 0;
	//@ open llist(l);
	struct node *next = l->head;
	struct node *temp = 0;
	l->head = 0;
	//@ close list(0);
	while (next != 0)
		//@ invariant l->head |-> ?n &*& list(n) &*& list(next);
	{
		previous = l->head;
		l->head = next;
		temp = next;
		//@ open list(temp);
		//@ open node(temp, _);
		next = temp->next;
		temp->next = previous;
		//@ close node(temp, previous);
		//@ close list(temp);
	}
	//@ open list(next);
	//@ close llist(l);
}